<?php

class UN_Admin_Editor_Page{
	
	public function __construct(){
		add_action('admin_print_styles-post.php', array(&$this, 'action_print_styles'));
		add_action('add_meta_boxes_feedback', array(&$this, 'action_add_meta_boxes'));
		add_action('post_updated_messages', array(&$this, 'filter_post_updated_messages'));
	}
	
	public function filter_post_updated_messages($messages){
		$messages[FEEDBACK][6] = __('Feedback was marked as reviewed');
		return $messages;
	}
	
	public function action_add_meta_boxes($post){
		global $post_new_file;
		if (isset($post_new_file)){
			$post_new_file = null;
		}
		remove_meta_box('submitdiv', FEEDBACK, 'side');
		add_meta_box('submitdiv', __('Publish'), array(&$this, 'post_submit_meta_box'), 
			FEEDBACK, 'side', 'default');
		$title = un_get_feedback_type_span($post->ID);
		add_meta_box('un-feedback-body', 
			$title . ($title ? ": " : '') . esc_html($post->post_title), 
			array(&$this, 'description_meta_box'),
			FEEDBACK);
	}
	
	
	
	public function action_print_styles(){
		global $post_type;
		if ($post_type == FEEDBACK) {
				wp_enqueue_style('un-admin', usernoise_url('/css/admin.css'));
		}
	}
	
	public function description_meta_box($post){
		do_action('description_meta_box_top', &$post);
		if (un_feedback_has_author($post->ID)){
			echo "<h4>" . __('Author') . ': ';
			un_feedback_author_link($post->ID);
			echo "</h4><br>";
		}
			
		do_action('description_meta_box_before_content', &$post);
		echo nl2br(esc_html($post->post_content));
		do_action('description_meta_box_bottom', &$post);
	}
		
	public function post_submit_meta_box($post) {
		global $action;
		$post_type = $post->post_type;
		$post_type_object = get_post_type_object($post_type);
		$can_publish = current_user_can($post_type_object->cap->publish_posts);
		require(usernoise_path('/html/publish-meta-box.php'));
	}
}

