jQuery(function($){
	if ($.browser.msie && $.browser.version == '6.0')
		return;
	$.facebox.settings.closeImage = $('#un_facebox_close_image_url').val();
	$.facebox.settings.opacity = "0.6";
	$.usernoise = {
		button:{
			init: function(){
				var button = $('#un_button');
				$('#un_button.bottom, #un_button.top').css('margin-left', "-" + ($('#un_button').width()) + "px");
				var property = button.attr('class');
				if ($.browser.msie && $.browser.version == '7.0')
					button.addClass('ie7');
				else if ($.browser.msie && $.browser.version == '8.0'){
					button.addClass('ie8');
				} else {
					button.addClass('css3');
				}
				$('#un_button.right.css3').css('margin-top', '-' + ($('#un_button').width()) + "px");
				$('#un_button.left.css3').css('margin-top', ($('#un_button').width() / 2)  + "px");
				var propOnStart = {};
				var propOnIn = {opacity: 1};
				var propOnOut = {opacity: 0.96};
				propOnStart[property] = '+=40px';
				propOnIn[property] = '+=3px';
				propOnOut[property] = '-=3px';
				button.css('display', 'block').animate(propOnStart, 'fast').hover(
					function(){$(this).animate(propOnIn, 100)},
					function(){$(this).animate(propOnOut, 100)}).click(function(event){
						$.usernoise.window.show();
						return false;
					});
			} /* init */ 
		}, /* Button */ 
		window: $.extend($('#un-window'),{
			show: function(){
				$.facebox($('#un-window'));
				$('#facebox').addClass('un');
				this.feedbackForm.init();
				var self = this;
				$(document).bind('loading.facebox', this.detectBrowser);
				$(document).bind('afterClose.facebox', function(){self.reset();});
			},
			detectBrowser: function(){
				if (!$('#facebox').hasClass('un')) return;
				$('#facebox').addClass('un');
				if ($.browser.msie && $.browser.version == '7.0')
					$('#facebox').addClass('un-ie7');
				if ($.browser.msie && $.browser.version == '8.0')
					$('#facebox').addClass('un-ie8');
			},
			reset: function(){
				$('#facebox').removeClass('un').removeClass('un-ie7').removeClass('un-ie8');
				this.feedbackForm.reset();
			},
			feedbackForm: $.extend($('#un-feedback-form'),{
				init: function(){
					this.find('.text').unAutoPlaceholder();
					$('#un-types-wrapper a').click(this.selectTypeHandler);
					this.submit(this.submitHandler);
				},
				selectTypeHandler: function(){
					var self = $.usernoise.window.feedbackForm;
					self.find('#un-types-wrapper a').removeClass('selected');
					$(this).addClass('selected');
					self.find('#un-type').val($(this).attr('id').replace('un-type-', ''));
					return false;
				},
				submitHandler: function(){
					var data  = jQuery('#un-feedback-form').unSerializeObject();
					$(document).trigger('un.feedback.submitting', data);
					var self = $.usernoise.window.feedbackForm;
					$.usernoise.window.feedbackForm.lock();
					$('#un-feedback-loader').show();
					self.errors.hide();
					$.post($('#un-feedback-form').attr('action'), data , function(response){
						self.unlock();
						response = $.parseJSON(response);
						if (response.success){
							$.usernoise.window.thankYou.show(response.html);
						} else {
							$.usernoise.window.feedbackForm.errors.show(response.errors);
						}
					});
					return false;
				},
				reset: function(){
					this.errors.hide();
					this.unlock();
					$.usernoise.window.thankYou.hide();
					$('#un-feedback-form-wrapper .text').removeClass('text-normal').addClass('text-empty');
					$('#un-feedback-form-wrapper form')[0].reset();
					$('#un-feedback-form-wrapper').show();
				},
				unlock: function(){
					$('#un-feedback-form input, #un-feedback-form textarea').removeAttr('disabled');
					$('#un-feedback-form-wrapper #un-types-wrapper a').click($.usernoise.window.feedbackForm.selectTypeHandler);
					$('#un-feedback-loader').hide();
					$('#un-feedback-submit').removeClass('disabled');
				}, 
				lock: function(){
					$('#un-feedback-form-wrapper #un-types-wrapper a').unbind('click');
					$('#un-feedback-form input, #un-feedback-form textarea').attr('disabled', 'disabled');
				}, 
				errors: {
					show: function(errors){
						$(errors).each(function(index, error){
							$('#un-feedback-errors').append($("<p />").text(error));
						});
						$('#un-feedback-errors-wrapper').fadeIn('fast');
					}, 
					hide: function(errors){
						$('#un-feedback-errors-wrapper').fadeOut('fast', function(){
							$('#un-feedback-errors').html(''); $('#un-feedback-errors-wrapper').hide();
						});
					}
				}
			}), /* Feedback form */
			thankYou:{
				show: function(html){
					$('#un-feedback-form-wrapper').fadeOut('fast', function(){
						$('#un-feedback-content').append($(html));
						$('#un-reset-feedback').click(function(){
							$(document).trigger('un.feedback.reset');
						});
					});
				},
				hide: function(){
					$('.un-thankyou').remove();
				}
			} /* Thank You */ 
		})
	}

	
	$.usernoise.button.init();
	$(document).bind('un.feedback.reset', function(){
		$.facebox.close();
	});
	
	$.fn.unAutoPlaceholder = function(){
		$(this).each(function(){
			$(this).attr('data-default', $(this).val());
			$(this).focus(function(){
				if ($(this).val() == $(this).attr('data-default')){
					$(this).val('');
					$(this).addClass('text-normal');
					$(this).removeClass('text-empty');
				}
			});
			$(this).blur(function(){
				if ($(this).val() == ''){
					$(this).val($(this).attr('data-default'));
					$(this).removeClass('text-normal');
					$(this).addClass('text-empty');
					
				}
			});
		});
	};
	
	$.fn.unSerializeObject = function(){
		var o = {};
		var a = this.serializeArray();
		$.each(a, function() {
			if (o[this.name]) {
				if (!o[this.name].push) {
					o[this.name] = [o[this.name]];
				}
				o[this.name].push(this.value || '');
			} else {
				o[this.name] = this.value || '';
			}
		});
		return o;
	};
});